/*
 * WaveHeader.h
 *
 * Bibliotheque qui sert a lire et 
 * verifier le contenu du header WAV
 *
 */

#ifndef WAVEHEADER_H
#define WAVEHEADER_H

typedef struct s_wave_header t_wave_header;
struct s_wave_header 
{
  char			riff_str[4];       // "RIFF"
  unsigned long		size;              // Taille du header+data
  char			wave_fmt_str[8];   // "WAVEfmt "
  unsigned long		smt_size;          // ?? toujours egal a 16
  unsigned short	format_tag;        // ?? toujours agal a 1
  unsigned short	chanels;           // 1: mono _ 2: stereo
  long			sample_rate;       // Frequence d'echantillonage
  unsigned long		avg_byte_per_sec;  // Taux d'octets/sec.
  unsigned short	block_align;       // ??
  unsigned short	bits_per_sample;   // Resolution: 8 ou 16 bits
  char			data_str[4];       // "data"
  unsigned long		data_size;         // Taille du sample
};

typedef struct s_wave_file t_wave_file;
struct s_wave_file 
{
  t_wave_header header;
  char*		name;
  int           file;
  int           dsp_file;
  long		processed_bytes;
};

t_wave_file wave_open(		/* ouvre un fichier WAV */
     char*				/* chemin du WAV a ouvrir */
);

void wave_close(		/* ferme un fichier WAV */ 
     t_wave_file			/* entete du fichier WAV a fermer */
);

t_wave_file wave_read_header(	/* lit l'entete d'un fichier WAV */
     char *				/* chemin du fichier en question */
);

int is_wave(			/* revoie  1 si le fichier est un WAV et 0 sinon */
     t_wave_header			/* entete du fichier WAV*/
);
 
#endif
