/*
** draw_wav.c for Gmurf in ~/Gmurf/gui
** 
** Made by Rmi Coupet
** Login   <inthy@sietch.inthy.fr>
** 
** Started on  Tue Feb 16 20:04:59 1999 Rmi Coupet
** Last update Thu Mar 18 17:30:56 1999 Rmi Coupet
*/

#include "draw_wav.h"

static gint		configure_left		(GtkWidget		*widget,
						 GdkEventConfigure	*event,
						 gpointer		data) ;
static gint		configure_right		(GtkWidget		*widget,
						 GdkEventConfigure	*event,
						 gpointer		data) ;
static gint		expose_left		(GtkWidget		*widget,
						 GdkEventExpose		*event,
						 gpointer		data) ;
static gint		expose_right		(GtkWidget		*widget,
						 GdkEventExpose		*event,
						 gpointer		data) ;
static gint		mouse_press		(GtkWidget		*widget,
						 GdkEventButton		*event,
						 gpointer		data) ;
static gint		mouse_release		(GtkWidget		*widget,
						 GdkEventButton		*event,
						 gpointer		data) ;
static gint		mouse_move		(GtkWidget		*widget,
						 GdkEventMotion		*event,
						 gpointer		data) ;



static gint	mouse_press(widget, 
			    event,
			    data)
GtkWidget	*widget;
GdkEventButton	*event ;
gpointer	data ;
{
  int		x ;
  size_t	pos ;
  Wavwin	*ww ;
  Waveditor	*wve ;
 
  ww = WAVWIN (data) ;
  wve = WAVEDITOR (widget) ;
  x = event->x;
  pos = wve->part_watched.x + ((wve->part_watched.y - wve->part_watched.x) * x)
      / wve->DrawingArea[LEFT]->allocation.width ;

  if (event->button == 1)
  {
    if (wve->there_is_a_selection)
    {
      if (pos <= wve->selection.y)
      {
	wve->selection.x = pos ;
	gtk_signal_emit_by_name(GTK_OBJECT (wve), "channel_right_configure") ;
      } else // if pos is on th right of sel.y
      {
	wve_erase_selection(wve) ;
      }
    } else  // if there is no selection 
    {
      if (wve->right_positionned)
      {
	if (pos <= wve->selection.y)
	{
	  wve->selection.x = pos ;
	  wve->left_positionned = TRUE;
	  wve->there_is_a_selection = TRUE ;
	  gtk_signal_emit_by_name(GTK_OBJECT (wve), "channel_right_configure") ;
	} else // if pos is on the right of sel.y
	{
	  wve_erase_selection(wve) ;
	}
      } else // if right is notpositionned
      { 
	wve->selection.x = pos ;
	wve->left_positionned = TRUE ;
	gtk_signal_emit_by_name(GTK_OBJECT (wve), "channel_right_configure") ;
      }
    }
  }  else if (event->button == 2)
  {
    wve_erase_selection(wve) ;
  } 
  else if (event->button == 3)
  {
    if (wve->there_is_a_selection)
    {
      if (pos >= wve->selection.x)
      {
	wve->selection.y = pos ;
	gtk_signal_emit_by_name(GTK_OBJECT (wve), "channel_right_configure") ;
      } else // if pos is on the left of sel.x
      {
	wve_erase_selection(wve) ;
	gtk_signal_emit_by_name(GTK_OBJECT (wve), "channel_right_configure") ;
      }
    } else  // if there is no selection 
    {
      if (wve->left_positionned)
      {
	if (pos >= wve->selection.x)
	{
	  wve->selection.y = pos ;
	  wve->right_positionned = TRUE;
	  wve->there_is_a_selection = TRUE ;
	  gtk_signal_emit_by_name(GTK_OBJECT (wve), "channel_right_configure") ;
	} else // if pos is on the left of sel.x
	{
	  wve_erase_selection(wve) ;
	}
      } else // if right is not positionned
      { 
	wve->selection.y = pos ;
	wve->right_positionned = TRUE ;
	gtk_signal_emit_by_name(GTK_OBJECT (wve), "channel_right_configure") ;
      }
    }
  } 
  return TRUE;
}

void		wve_erase_selection(wve)
Waveditor	*wve ;
{
  wve->selection.x = 0 ;
  wve->selection.y = 0 ;
  wve->there_is_a_selection = FALSE ;
  wve->right_positionned = FALSE ;
  wve->left_positionned = FALSE ;
  gtk_signal_emit_by_name(GTK_OBJECT (wve), "channel_right_configure") ;
}


static gint	mouse_release(widget, 
			      event,
			      data)
GtkWidget	*widget;
GdkEventButton	*event ;
gpointer	data ;
{  
//  Wavwin	*ww ;
  
  return TRUE;
}


static gint	mouse_move(widget,
			   event,
			   data)
GtkWidget	*widget ;
GdkEventMotion	*event ;
gpointer	data ;
{
  int x, y;
  GdkModifierType state;
  Waveditor	*wve ;
  Wavwin	*ww ;
  size_t	pos ;
  

  wve = WAVEDITOR (widget) ;
  ww = WAVWIN (data) ;
  
  if (event->is_hint)
    gdk_window_get_pointer(event->window, &x, &y, &state);
  else
  {
    x = event->x;
    y= event->y;
    state = event->state;
  }

  if ( (x > 0) || (x < wve->DrawingArea[LEFT]->allocation.width) )
  {
    pos = wve->part_watched.x + (((double)(wve->part_watched.y - wve->part_watched.x)) * x)
      / (double) wve->DrawingArea[LEFT]->allocation.width ;
    gtk_label_set_text(GTK_LABEL (wve->SU_label), ultoa((unsigned long int) pos)) ;
    gtk_label_set_text(GTK_LABEL (wve->Sec_label), ultoa((unsigned long int) (pos / 44.1))) ;
  }
  
  
//  if (state & GDK_BUTTON1_MASK && pixmap != NULL)
  //   ;
  return TRUE;
}


/* Redraw the screen from the backing pixmap */
static gint	expose_left (widget, 
			     event,
			     data)
GtkWidget	*widget ;
GdkEventExpose	*event ;
gpointer	data ;
{
  Waveditor	*wve ;

  wve = WAVEDITOR (widget) ;
  gdk_draw_pixmap(wve->DrawingArea[LEFT]->window,
		  wve->DrawingArea[LEFT]->style->black_gc,
		  wve->pixmap[LEFT],
		  event->area.x, event->area.y,
		  event->area.x, event->area.y,
		  event->area.width, 
		  event->area.height);
  return FALSE;
}


static gint	expose_right (widget,
			      event,
			      data)
GtkWidget	*widget ;
GdkEventExpose	*event ;
gpointer	data ;
{
  Waveditor		*wve ;

  wve = WAVEDITOR (widget) ;
  gdk_draw_pixmap(wve->DrawingArea[RIGHT]->window,
		  wve->DrawingArea[RIGHT]->style->black_gc,
		  wve->pixmap[RIGHT],
		  event->area.x, event->area.y,
		  event->area.x, event->area.y,
		  event->area.width, 
		  event->area.height);
  return FALSE;
}


static gint		configure_left (widget,
					event,
					data)
GtkWidget		*widget;
GdkEventConfigure	*event ;
gpointer		data ;
{
  Waveditor	*wve ;
  
  wve = WAVEDITOR (widget) ;
  if (wve->pixmap[LEFT])
    gdk_pixmap_unref(wve->pixmap[LEFT]);
  wve->pixmap[LEFT] = gdk_pixmap_new(wve->DrawingArea[LEFT]->window,
				     wve->DrawingArea[LEFT]->allocation.width,
				     wve->DrawingArea[LEFT]->allocation.height,
				     -1);
//  wve->draw_wav_left(widget, data) ;
  return TRUE;
}


static gint		configure_right (widget,
					 event,
					 data)
GtkWidget		*widget;
GdkEventConfigure	*event ;
gpointer		data ;
{
  Waveditor	*wve ;
  Wavwin	*ww ;
  
  wve = WAVEDITOR (widget) ;
  ww = WAVWIN (data) ;
  if (wve->pixmap[RIGHT])
    gdk_pixmap_unref(wve->pixmap[RIGHT]);
  wve->pixmap[RIGHT] = gdk_pixmap_new(wve->DrawingArea[RIGHT]->window,
				     wve->DrawingArea[RIGHT]->allocation.width,
				     wve->DrawingArea[RIGHT]->allocation.height,
				     -1);
  wve->draw_wav_right(widget, data) ;
  return TRUE; 
}


void		switch_notebook(widget)
GtkWidget	*widget ;
{
  static int	current = STANDARD ;
  Wavwin 	*ww ;
  
  printf("deb_switch\n");
  if (widget != NULL){
    ww = WAVWIN (widget) ;
    gtk_widget_hide(WAVEDITOR (ww->wve[current])->DrawingArea[LEFT]) ;
    gtk_widget_hide(WAVEDITOR (ww->wve[current])->DrawingArea[RIGHT]) ;
    current = gtk_notebook_current_page(GTK_NOTEBOOK (ww->notebook));
    printf("current %d\n", current);	
    if (current >= 0){
      gtk_widget_show(WAVEDITOR (ww->wve[current])->DrawingArea[LEFT]) ;
      gtk_widget_show(WAVEDITOR (ww->wve[current])->DrawingArea[RIGHT]) ;
    }
  }
  printf("fin_switch\n");
}  

void  	init_draw_funcs(ww) 
Wavwin	*ww ;
{
  WAVEDITOR (ww->wve[STANDARD])->draw_wav_right = draw_wav_basic ;
  //WAVEDITOR (ww->wve[STANDARD])->draw_wav_left = draw_wav_left_basic ;
  //WAVEDITOR (ww->wve[STANDARD])->draw_wav_right = draw_wav_right_basic ;
}

void 		scroll(widget, event)
GtkWidget	*widget ;
GdkEvent	*event ;
{
  Waveditor	*wve ;
  GtkAdjustment	*adj ;

  wve = WAVEDITOR (widget) ;
  adj = gtk_range_get_adjustment(GTK_RANGE (wve->hscrollbar));
  wve->part_watched.y = adj->value + adj->page_size ;
  wve->part_watched.x = adj->value ;
//  gtk_signal_emit_by_name(GTK_OBJECT (wve), "channel_left_configure") ;
  gtk_signal_emit_by_name(GTK_OBJECT (wve), "channel_right_configure") ;
}


void		init_wve(wve, ww)
Waveditor	*wve ;
Wavwin		*ww ;
{
  GtkAdjustment	*adj ;
  
  wve->selection.x = 0 ;
  wve->selection.y = 0 ;

  wve->part_watched.x = 0 ;
  wve->part_watched.y = ww->tempgmurf->temp_size / (4 * DEFAULT_ZOOM);
/*  gtk_ruler_set_range(GTK_RULER (wve->hruler), wve->part_watched.x,
		      wve->part_watched.y, wve->part_watched.x, 
		      wve->part_watched.y);
*/

  adj = gtk_range_get_adjustment(GTK_RANGE (wve->hscrollbar)) ;
  adj->upper = ww->tempgmurf->temp_size / 4;
  adj->lower = 0 ;
  adj->value = 0 ;
  adj->page_increment = 1 ;
  adj->page_size = wve->part_watched.y - wve->part_watched.x ;
  adj->step_increment = adj->page_size / STEP_INC ;
  gtk_range_set_adjustment(GTK_RANGE (wve->hscrollbar), adj) ;

  gtk_signal_connect_object(GTK_OBJECT (GTK_RANGE (wve->hscrollbar)->adjustment),
			    "value_changed", GTK_SIGNAL_FUNC (scroll), 
			    GTK_OBJECT (wve));


  gtk_signal_connect(GTK_OBJECT (wve), "channel_left_button", 
  		     GTK_SIGNAL_FUNC (mouse_press), (gpointer) ww); 
  gtk_signal_connect(GTK_OBJECT (wve), "channel_right_button", 
  	 	     GTK_SIGNAL_FUNC (mouse_press), (gpointer) ww);

  gtk_signal_connect(GTK_OBJECT (wve), "channel_left_motion", 
  		     GTK_SIGNAL_FUNC (mouse_move), (gpointer) ww); 
  gtk_signal_connect(GTK_OBJECT (wve), "channel_right_motion", 
  	 	     GTK_SIGNAL_FUNC (mouse_move), (gpointer) ww);

  gtk_signal_connect(GTK_OBJECT (wve), "channel_left_configure", 
  		     GTK_SIGNAL_FUNC (configure_left), (gpointer) ww); 
  gtk_signal_connect(GTK_OBJECT (wve), "channel_right_configure", 
  	 	     GTK_SIGNAL_FUNC (configure_right), (gpointer) ww); 

  gtk_signal_connect(GTK_OBJECT (wve), "channel_left_expose", 
  		     GTK_SIGNAL_FUNC (expose_left), (gpointer) ww); 
  gtk_signal_connect(GTK_OBJECT (wve), "channel_right_expose", 
  	 	     GTK_SIGNAL_FUNC (expose_right), (gpointer) ww);

  gtk_signal_connect(GTK_OBJECT (wve->DrawingArea[LEFT]), "button_release_event",
		     GTK_SIGNAL_FUNC (mouse_release), (gpointer) ww) ;
  gtk_signal_connect(GTK_OBJECT (wve->DrawingArea[RIGHT]), "button_release_event",
		     GTK_SIGNAL_FUNC (mouse_release), (gpointer) ww) ;
  
}














